package lsystemsapp.gui;

import lsystemsapp.lsystems.*;

/*
 Watek sprawdzajacy, czy obliczenie ciagu symboli juz sie zakonczylo
 i wysylajacy sygnal, ze juz mozna rysowac. Kontroluje klase
 SymbolSequenceCreator, ktora rowniez jest osobnym watkiem.
*/

public class SymbolSequenceCreatorWatcher extends Thread {
    private SymbolSequenceCreator symbolSequenceCreator;
    private FractalDrawing fractalDrawing;
    private boolean stop=false;
    public SymbolSequenceCreatorWatcher(SymbolSequenceCreator symbolSequenceCreator, FractalDrawing gui) {
        this.symbolSequenceCreator=symbolSequenceCreator;
        this.fractalDrawing=gui;
    }

    public void run(){
        try{
            while (symbolSequenceCreator.isAlive()){
                sleep(200);
                if(stop) return;
            }
        }
        catch(InterruptedException e){
            System.out.println(e.toString());
        }

        String symbols = symbolSequenceCreator.getSymbolSequence();
        //System.out.println(symbols);
        fractalDrawing.setSymbolSequence(symbols);
        fractalDrawing.repaint();
    }

    public void kill(){
        stop=true;
    }
}
