package lsystemsapp.lsystems;

import java.util.*;

/**
 Gramatyka. Zawiera wszystko co potrzebne do wygenerowania ciagu
 rozkazow dla zolwia (axiom i produkcje), a takze dane dotyczace
 rysowania (kat skretu, zasieg ruchu).
*/


public class Grammar{
    public String axiom="F";
    private ArrayList productionGroups = new ArrayList();
    public double angle=45, distance=5;
    public Random random = new Random();
    public String name = "noname";
    public Grammar() {
    }

    public void addProduction(Production p){
        //System.out.println(p.toString());
        for(int i=0;i<productionGroups.toArray().length;i++){
            ProductionGroup pg = (ProductionGroup)productionGroups.get(i);
            if(pg.addProduction(p)) {
                return;
            }
        }
        ProductionGroup pg = new ProductionGroup();
        pg.addProduction(p);
        productionGroups.add(pg);
    }

    public String getProductionRightSide(String leftSide){
        for(int i=0;i<productionGroups.toArray().length;i++){
            ProductionGroup pg = (ProductionGroup)productionGroups.get(i);
            //System.out.println(pg.toString());
            if(pg.getLeftSide().equals(leftSide)) {
                //if(pg.getProduction(random)==null) return "";
                return pg.getProduction(random).getRightSide();
            }
        }

        return null;
    }

    public String toString(){
        return name;
    }

}
