package lsystemsapp.lsystems;

import java.awt.*;
import java.util.*;

import javax.vecmath.*;

/**
 Definicja wielokata, wektor punktow. Pozwala utworzyc standardowy
 obiekt klasy java.awt.Polygon przeskalowany i umieszczony w globalnym
 ukladzie wspolrzednych (Poly2D jest definiowany w ukladzie wspolrzednych
 zolwia.
*/

public class Poly2D {
    private ArrayList points = new ArrayList();
    private Color color = new Color(0, 0, 0);

    public Poly2D(){
    }

    public void setColor(Color color){
        this.color=color;
    }

    public Color getColor(){
        return color;
    }

    public void addPoint(double x, double y){
        points.add(new Point2d(x, y) );
    }

    public void addPoint(Point2d p){
        points.add(p);
    }

    public int getPointCount(){
        return points.toArray().length;
    }

    private Point2d getPoint(int nr){
        return (Point2d)points.get(nr);
    }

    public Polygon createPolygon(Skalowanie s, Matrix3d trans){
        int p_num = points.toArray().length;
        int ret_x[] = new int[p_num];
        int ret_y[] = new int[p_num];
        for(int i=0;i<p_num;i++){
            Point3d p = new Point3d(getPoint(i).x, getPoint(i).y, 1);
            trans.transform(p);
            ret_x[i] = s.daj_x(p.x);
            ret_y[i] = s.daj_y(p.y);
            //System.out.println("("+p.x+", "+p.y+")");
        }
        //System.out.println("---");
        //check(ret_x);

        return new Polygon(ret_x, ret_y, p_num);
    }

    public Poly2D shallowCopy(){
        Poly2D ret = new Poly2D();
        for(int i=0;i<points.toArray().length;i++)
            ret.addPoint((Point2d)points.get(i));

        return ret;
    }



}
