package lsystemsapp.lsystems;

import java.util.ArrayList;
import java.util.Random;

/*
 Grupa produkcji o takim samym symbolu lewej strony.
 Pozwala wylosowac produkcje.
*/

public class ProductionGroup {
    private String leftSide=null;
    private ArrayList productions;
    private double probabilitiesSum=0;

    public ProductionGroup() {
        productions = new ArrayList();
    }

    public boolean addProduction(Production p){
        if(leftSide==null)
            leftSide=p.getLeftSide();
        else
            if(!(leftSide.equals(p.getLeftSide())) ) return false;

        productions.add(p);
        probabilitiesSum+=p.getProbability();
        return true;
    }

    private double productionProbabilitiesSum(){
        double sum=0;
        for(int i=0;i<productions.toArray().length;i++)
            sum+= ((Production)productions.get(i)).getProbability();
        return sum;
    }

    public Production getProduction(Random random){
        double rand = random.nextDouble();
        //double probabilitiesSum=productionProbabilitiesSum();
        double previousProbabilitiesSum=0;
        for(int i=0;i<productions.toArray().length;i++){
            Production p = (Production)productions.get(i);
            //System.out.println(i+": "+rand+" "+previousProbabilitiesSum+" "+p.getProbability()/productionProbabilitiesSum());

            double lower = previousProbabilitiesSum;
            double upper = previousProbabilitiesSum+ p.getProbability()/probabilitiesSum;
            //System.out.print("Production "+i+" ("+p.toString()+") ");
           // System.out.print(lower+"<="+rand+"<="+ upper);

            if(rand>=lower &&
               rand<=upper) {
                //System.out.println(" OK");
                return p;
            }
            //System.out.println(" ");
            previousProbabilitiesSum=upper;
        }

        return null;
    }

    public String getLeftSide(){
        return leftSide;
    }

    public String toString(){
        String ret="";
        for(int i=0;i<productions.toArray().length;i++){
            Production p = (Production) productions.get(i);
            ret+=i+": "+p.toString()+"\n";
        }

        return ret;
    }



}
