package lsystemsapp.lsystems;

/*
 Generuje ciag symboli dla danej gramatyki (klasa Grammar) i podanej
 ilosci iteracji. Poniewaz jest to najbardziej zlozony obliczoniowo
 proces w trakcie powstawania fraktalnego obrazka, jest on wykonywany w
 osobnym watku, aby nie blokowac interfejsu uzytkownika.
*/

public class SymbolSequenceCreator extends Thread {
    private Grammar grammar;
    private int iterations;
    private String symbolSequence;
    private boolean stop=false;
    private String startingSequence=null;

    public SymbolSequenceCreator(Grammar grammar, int iterations) {
        this.grammar = grammar;
        this.iterations = iterations;
    }

    public SymbolSequenceCreator(Grammar grammar, int iterations, String startingSequence) {
        this.grammar = grammar;
        this.iterations = iterations;
        this.startingSequence=startingSequence;
    }


    public void run(){
        String last;
        if(startingSequence==null)
            last = grammar.axiom;
        else
            last = startingSequence;

        String next = "";
        for(int itrs=0;itrs<iterations;itrs++){
            next="";
            for (int i = 0; i < last.length(); i++) {
                if(stop) return;
                String str = grammar.getProductionRightSide(last.substring(i , i +1));
                if(str!=null)
                    next += str;
                else
                    next += last.substring(i , i +1);
            }
            last = next;
        }

        symbolSequence=last;
    }

    public void kill(){
        stop=true;
    }

    public String getSymbolSequence() {
        return symbolSequence;
    }

}
