package lsystemsapp.lsystems;

import javax.vecmath.*;
import java.util.Stack;

/*
 Zolw zawiera metody do poruszania sie w przestrzeni 2D i rysowania.
 Przechowuje informacje o swoim aktualnym polozeniu i stos na
 ktory moze je odkladac.
*/

public class Turtle {
    private Matrix3d transMatrix = new Matrix3d();
    private Stack stack = new Stack();
    public Turtle() {
        transMatrix.normalize();
    }

    public void forward(double dist){

        Point3d p1 = new Point3d(0, 0, 1);
        Point3d p2 = new Point3d(0, dist, 1);

        transMatrix.transform(p1);
        transMatrix.transform(p2);
        Matrix3d newPos = new Matrix3d(); newPos.normalize();
        newPos.setColumn(2,p2.x-p1.x,p2.y-p1.y,1);

        transMatrix.mul(newPos, transMatrix);
    }

    public static void check(Matrix3d m){
        Point3d p = new Point3d(0,0,1);
        Point3d p2 = new Point3d(0,1,1);
        m.transform(p);
        m.transform(p2);
        System.out.println("Pos: "+p+", Rot: "+p2);
    }

    public void turn(double angle){
        //transMatrix.rotZ(-Math.PI*angle/180.);
        Matrix3d rot = new Matrix3d();
        rot.normalize();
        rot.rotZ(-Math.PI*angle/180.);

        Matrix3d pos = new Matrix3d();
        pos.normalize();
        pos.setColumn(2,transMatrix.m02, transMatrix.m12, 1);
        //System.out.println("pos: "+pos.toString());

        Matrix3d inv_pos = new Matrix3d();
        inv_pos.normalize();
        inv_pos.invert(pos);

        transMatrix.mul(inv_pos, transMatrix);
        transMatrix.mul(rot, transMatrix);
        transMatrix.mul(pos, transMatrix);
    }

    protected void pushTransform(){
        stack.push(new Matrix3d(transMatrix));
    }

    protected void popTransform(){
        if(!stack.empty())
            transMatrix = (Matrix3d)stack.pop();
    }

    public double[] getPosition(){
        Vector3d v = new Vector3d(0,0,1);
        transMatrix.transform(v);
        return new double[]{v.x, v.y};
    }

    protected Matrix3d getTransformMatrix(){
        return transMatrix;
    }

}
