package lsystemsapp.lsystems;


import java.awt.*;

/*
 Rozszerza mozliwosci klasy Turtle. Potrafi interpretowac ciagi symboli
 zgodnie z podanymi wytycznymi (czerpie je z obiektow klasy
 SymbolInterpretationGroup i TurtleOrder). Rysujac zapamietuje swoje
 skrajne polozenia, co jest wykorzystywane przy kadrowaniu rysunku.
*/

public class TurtleDrawer extends Turtle {

    static double distance = 3,half_width=1;
    public double horizontal_max=0, horizontal_min=0, vertical_max=0, vertical_min=0;
    public TurtleDrawer() {
        super();
    }

    public void interpretSymbol(String symbol, Graphics2D g, Skalowanie s, Grammar grammar, SymbolInterpretationGroup symbolInterpretationGroup) {
        //System.out.println("symbol: "+symbol);

        if(symbolInterpretationGroup.get(symbol)!=null){
            //System.out.println("in");
            SymbolInterpretation si = (SymbolInterpretation)symbolInterpretationGroup.get(symbol);
            Object o;
            //System.out.println(si.getOrderCount());
            while((o=si.getNextOrder())!=null){
                //System.out.println(o.getClass().getName());

                try{
                    TurtleOrder turtleOrder=(TurtleOrder)o;
                    if(turtleOrder.getOrderType().equals("fd")){
                        double p1[] = getPosition();
                        double dist = distance;
                        if(turtleOrder.getArgument()!=null)
                            dist = turtleOrder.getArgument().doubleValue();
                        forward(dist);
                        double p2[] = getPosition();
                        g.setColor(new Color(0,0,0));
                        g.drawLine(s.daj_x(p1[0]), s.daj_y(p1[1]), s.daj_x(p2[0]),
                                   s.daj_y(p2[1]));
                    }
                    if(turtleOrder.getOrderType().equals("ff")){

                        double dist = distance;
                        if(turtleOrder.getArgument()!=null)
                            dist = turtleOrder.getArgument().doubleValue();
                        forward(dist);
                    }
                    else
                    if(turtleOrder.getOrderType().equals("turn")){
                        double angle = grammar.angle;
                        if(turtleOrder.getArgument()!=null)
                            angle = turtleOrder.getArgument().doubleValue();
                        turn(angle);
                    }
                    if(turtleOrder.getOrderType().equals("pop")){
                        popTransform();
                    }
                    if(turtleOrder.getOrderType().equals("push")){
                        pushTransform();
                    }

                    //System.out.println("order");
                    continue;
                }
                catch(ClassCastException e){}

                try{
                    Poly2D poly = (Poly2D)o;
                    g.setColor(poly.getColor());
                    g.fillPolygon(poly.createPolygon(s, getTransformMatrix()));
                }
                catch(ClassCastException e){}

            }


        }
        else{//defaults
            interpretSymbolDefaults(symbol, g, s, grammar);

        }


        double[] pos = getPosition();
        if(pos[0]<horizontal_min) horizontal_min=pos[0];
        if(pos[0]>horizontal_max) horizontal_max=pos[0];
        if(pos[1]<vertical_min) vertical_min=pos[1];
        if(pos[1]>vertical_max) vertical_max=pos[1];
    }

    public void interpretSymbolDefaults(String symbol, Graphics2D g, Skalowanie s, Grammar grammar) {

        if (symbol.equals("F")) {
            double p1[] = getPosition();
            g.setColor(new Color(0, 0, 0));
            forward(distance);
            double p2[] = getPosition();
            g.drawLine(s.daj_x(p1[0]), s.daj_y(p1[1]), s.daj_x(p2[0]),
                       s.daj_y(p2[1]));

        } else
        if (symbol.equals("f")) {
            forward(distance);
        } else
        if (symbol.equals("-")) {
            turn( -grammar.angle);
        } else
        if (symbol.equals("+")) {
            turn(grammar.angle);
        } else
        if (symbol.equals("[")) {
            pushTransform();
        } else
        if (symbol.equals("]")) {
            popTransform();
        } else {
            //System.out.println("Symbol unknown");
        }

    }

    public void interpretSymbolSequence(String sequence, Graphics2D g, Skalowanie s, Grammar grammar, SymbolInterpretationGroup symbolInterpretationGroup){
        for(int i=0;i<sequence.length();i++)
            interpretSymbol(sequence.substring(i,i+1),g,s,grammar, symbolInterpretationGroup);
    }

}
